//
//  AquaButtonView.m
//  Aqua
//
//  Created by kunii on 11/06/12.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "AquaButtonView.h"


@implementation AquaButtonView
@synthesize textLabel;

/*
 Cocoa Fundation Design Concepts
 Toll-Free Bridged Types
 
 Note from the example that the memory management functions and methods are 
 also interchangeable—you can use CFRelease with a Cocoa object and release 
 and autorelease with a Core Foundation object.
 */
- (UIImage*)createLayerGradImage:(CGSize)contentsSize
{
    UIGraphicsBeginImageContext(contentsSize);
    CGContextRef context = UIGraphicsGetCurrentContext();
    float hue = 0.0;
    float saturation = 1.0;
    float brightness = 1.0;
    CGColorRef halationTop = [UIColor colorWithHue:hue 
                                        saturation:saturation * 0.2 
                                        brightness:brightness 
                                             alpha:1].CGColor;
    CGColorRef halationBottom = [UIColor colorWithHue:hue 
                                           saturation:saturation * 0.8 
                                           brightness:brightness * 0.8 
                                                alpha:1].CGColor;
    CGColorRef normalTop = [UIColor colorWithHue:hue 
                                      saturation:saturation 
                                      brightness:brightness * 0.8 
                                           alpha:1].CGColor;
    CGColorRef normalBottom = [UIColor colorWithHue:hue 
                                         saturation:saturation 
                                         brightness:brightness 
                                              alpha:1].CGColor;
    NSArray* colors = [NSArray arrayWithObjects:
                       (id)halationTop, 
                       (id)halationBottom, 
                       (id)normalTop, 
                       (id)normalBottom, nil];
    CGFloat locations[] = {0.0, 0.5, 0.5, 1.0};
    CGGradientRef gradient = CGGradientCreateWithColors(CGColorGetColorSpace(halationTop), 
                                                        (CFArrayRef)colors, locations);
    CGPoint gradientStartPoint = CGPointZero;
    CGPoint gradientEndPoint = CGPointMake(0, contentsSize.height);
    CGContextDrawLinearGradient(context, 
                                gradient, 
                                gradientStartPoint, 
                                gradientEndPoint, 
                                kCGGradientDrawsAfterEndLocation);
    //	グラデーション情報は用が無くなったので解放。
    CGGradientRelease(gradient);
    //	画像バッファをCGImageRefに変換。
    UIImage* image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return image;
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
#define USE_CAGradientLayer 1   //  createLayerGradImageを試す場合は0にする
#if USE_CAGradientLayer
        CAGradientLayer* internalButton = [CAGradientLayer layer];
        internalButton.frame = self.bounds;
        float hue = 0.0;
        float saturation = 1.0;
        float brightness = 1.0;
        CGColorRef halationTop = [UIColor colorWithHue:hue 
                                            saturation:saturation * 0.2 
                                            brightness:brightness 
                                                 alpha:1].CGColor;
        CGColorRef halationBottom = [UIColor colorWithHue:hue 
                                               saturation:saturation * 0.8 
                                               brightness:brightness * 0.8 
                                                    alpha:1].CGColor;
        CGColorRef normalTop = [UIColor colorWithHue:hue 
                                          saturation:saturation 
                                          brightness:brightness * 0.8 
                                               alpha:1].CGColor;
        CGColorRef normalBottom = [UIColor colorWithHue:hue 
                                             saturation:saturation 
                                             brightness:brightness 
                                                  alpha:1].CGColor;
        NSMutableArray *colors = [NSArray arrayWithObjects:
                                  (id)halationTop, 
                                  (id)halationBottom, 
                                  (id)normalTop, 
                                  (id)normalBottom, nil];
        NSMutableArray *locations = [NSArray arrayWithObjects:
                                     [NSNumber numberWithFloat:0.0],
                                     [NSNumber numberWithFloat:0.5],
                                     [NSNumber numberWithFloat:0.5],
                                     [NSNumber numberWithFloat:1.0],nil];
        [internalButton setColors:colors];
        [internalButton setLocations:locations];
#else
        CALayer* internalButton = [CALayer layer];
        internalButton.frame = self.bounds;
        internalButton.contents = (id)[self createLayerGradImage:CGSizeMake(1, frame.size.height)].CGImage;
#endif
        internalButton.cornerRadius = 8;
        internalButton.masksToBounds = YES;                
        internalButton.borderWidth = 1;
        [self.layer addSublayer:internalButton];

        textLabel = [[[UILabel alloc] initWithFrame:self.bounds] autorelease];
        textLabel.font = [UIFont boldSystemFontOfSize:18];
        textLabel.textColor = [UIColor whiteColor];
        textLabel.textAlignment = UITextAlignmentCenter;
        textLabel.shadowColor = [UIColor grayColor];
        textLabel.backgroundColor = [UIColor clearColor];
        [self addSubview:textLabel];
    }
    return self;
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

- (void)dealloc
{
    [super dealloc];
}

@end
